param T;

set TIMESTEPS ordered :=0..T;
set ENDSTEPS ordered := TIMESTEPS diff {first(TIMESTEPS)};
set ASSETS;

param asset_developpment{ENDSTEPS,ASSETS};
param initial_assets{ASSETS};
param inflow{TIMESTEPS};

var owned{TIMESTEPS,ASSETS} >=0;
var buy{TIMESTEPS,ASSETS} >=0;
var sell{TIMESTEPS,ASSETS} >=0;

maximize end_wealth:
	 sum{ a in ASSETS} owned[last(TIMESTEPS),a];

subject to mass_conservation{t in TIMESTEPS}:
     sum{ a in ASSETS}(buy[t,a]-sell[t,a])=inflow[t];

subject to developpment{t in TIMESTEPS, a in ASSETS:t != first(TIMESTEPS)}:
     owned[t,a]=
     	  asset_developpment[t,a]*owned[prev(t),a]
     	  +buy[t,a]-sell[t,a];

subject to initial_owned{a in ASSETS}:
     owned[first(TIMESTEPS),a]=initial_assets[a]+buy[first(TIMESTEPS),a]-sell[first(TIMESTEPS),a];


