param last_node;
set NODES ordered := 0..last_node;

param prob{NODES};
param parent{NODES};
param level{n in NODES}:=if parent[n]==-1 then 0 else 1+level[parent[n]];

set LEAFS within NODES := setof{ n in NODES : level[n]=max{i in NODES} level[i]} n;
set ROOT within NODES := setof{ n in NODES : parent[n]==-1} n;


set ASSETS;

param asset_developpment{ASSETS,NODES diff ROOT};
param initial_assets{ASSETS};
param inflow{NODES};


var owned{ASSETS,NODES} >=0;
var buy{ASSETS,NODES} >=0;
var sell{ASSETS, NODES} >=0;

maximize end_wealth:
     sum{ a in ASSETS, n in LEAFS} owned[a,n]*prob[n];

subject to mass_conservation{n in NODES}:
     sum{ a in ASSETS}(buy[a,n]-sell[a,n])=inflow[n];

subject to developpment{n in NODES diff ROOT, a in ASSETS}:
     owned[a,n]=
     	  asset_developpment[a,n]*owned[a,parent[n]]
     	  +buy[a,n]-sell[a,n];

subject to initial_owned{a in ASSETS, n in ROOT}:
     owned[a,n]=initial_assets[a]+buy[a,n]-sell[a,n];
